#include "_7_segment.h"

void _7_segment_init (void) {
	DDRD = 0xFB;													//Datenleitungen
	PORTD = 0xFB;
	DDRC = 0xFF;													//Steuerleitungen & sonstiges
	PORTC = (1<<PC4) | (1<<PC3) | (1<<PC2) | (1<<PC1) | (1<<PC0);
	PORTC &= ~(1<<PC5);											//Summer aus
}

void _7_segment_rotate (void) {
	PORTC = (PORTC & 0xF0) | 0x0F;									//alle Anzeigen aus
	switch (display_array[display_counter]) {
		case '0':	PORTD = (PORTD & 0x00) | ~0x7B; break;			//abcdef
		case '1':	PORTD = (PORTD & 0x00) | ~0x0A; break;			//bc
		case '2':	PORTD = (PORTD & 0x00) | ~0xB3; break;			//abdeg
		case '3':	PORTD = (PORTD & 0x00) | ~0x9B; break;			//abcdg
		case '4':	PORTD = (PORTD & 0x00) | ~0xCA; break;			//bcfg
		case '5':	PORTD = (PORTD & 0x00) | ~0xD9; break;			//acdfg
		case '6':	PORTD = (PORTD & 0x00) | ~0xF9; break;			//acdefg
		case '7':	PORTD = (PORTD & 0x00) | ~0x0B; break;			//abc
		case '8':	PORTD = (PORTD & 0x00) | ~0xFB; break;			//abcdefg
		case '9':	PORTD = (PORTD & 0x00) | ~0xDB; break;			//abcdfg
	}
	switch (display_counter) {
		case 0:		PORTC &= ~(1<<PC0);  break;					//Zuschalten der jeweiligen Anzeige
		case 1:		PORTC &= ~(1<<PC1); break;
		case 2:		PORTC &= ~(1<<PC2); break;
		case 3:		PORTC &= ~(1<<PC3); break;
	}
	display_counter++;												//steter Wechsel zwischen Anzeigen
	if (display_counter == 4)
		display_counter = 0;
}

